AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException AppDomain.UnhandledException Event

Definizione

Si verifica quando non viene intercettata un'eccezione.Occurs when an exception is not caught.

public:
 virtual event UnhandledExceptionEventHandler ^ UnhandledException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event UnhandledExceptionEventHandler UnhandledException;
member this.UnhandledException : UnhandledExceptionEventHandler 
Public Custom Event UnhandledException As UnhandledExceptionEventHandler 

Implementazioni

Attributi

Esempi

Nell'esempio seguente viene illustrato UnhandledException l'evento.The following example demonstrates the UnhandledException event. Definisce un gestore eventi, MyHandler, che viene richiamato ogni volta che viene generata un'eccezione non gestita nel dominio applicazione predefinito.It defines an event handler, MyHandler, that is invoked whenever an unhandled exception is thrown in the default application domain. Genera quindi due eccezioni.It then throws two exceptions. Il primo è gestito da un blocco try/catch .The first is handled by a try/catch block. Il secondo non è gestito e richiama la MyHandle routine prima del termine dell'applicazione.The second is unhandled and invokes the MyHandle routine before the application terminates.

// The example should be compiled with the /clr:pure compiler option.
using namespace System;
using namespace System::Security::Permissions;

public ref class Example
{


private:
   static void MyHandler(Object^ sender, UnhandledExceptionEventArgs^ args)
   {
      Exception^ e = dynamic_cast<Exception^>(args->ExceptionObject);
      Console::WriteLine( "MyHandler caught : {0}", e->Message );
      Console::WriteLine("Runtime terminating: {0}", args->IsTerminating);
   }
   
public: 
   [SecurityPermissionAttribute( SecurityAction::Demand, ControlAppDomain = true )]
   static void Main()
   {
      AppDomain^ currentDomain = AppDomain::CurrentDomain;
      currentDomain->UnhandledException += gcnew UnhandledExceptionEventHandler(Example::MyHandler);
      try
      {
         throw gcnew Exception("1");
      }
      catch (Exception^ e) 
      {
         Console::WriteLine( "Catch clause caught : {0}\n", e->Message );
      }

      throw gcnew Exception("2");
   }
};

void main()
{
   Example::Main();
}   
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()
//          at mainCRTStartup(String[] arguments)
using System;
using System.Security.Permissions;

public class Example 
{
   [SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.ControlAppDomain)]
   public static void Main()
   {
      AppDomain currentDomain = AppDomain.CurrentDomain;
      currentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyHandler);
      
      try {
         throw new Exception("1");
      } catch (Exception e) {
         Console.WriteLine("Catch clause caught : {0} \n", e.Message);
      }

      throw new Exception("2");
   }
   
   static void MyHandler(object sender, UnhandledExceptionEventArgs args) 
   {
      Exception e = (Exception) args.ExceptionObject;
      Console.WriteLine("MyHandler caught : " + e.Message);
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating);
   }
}
// The example displays the following output:
//       Catch clause caught : 1
//       
//       MyHandler caught : 2
//       Runtime terminating: True
//       
//       Unhandled Exception: System.Exception: 2
//          at Example.Main()  
Module Example
   Sub Main()
      Dim currentDomain As AppDomain = AppDomain.CurrentDomain
      AddHandler currentDomain.UnhandledException, AddressOf MyHandler
      
      Try
         Throw New Exception("1")
      Catch e As Exception
         Console.WriteLine("Catch clause caught : " + e.Message)
         Console.WriteLine()
      End Try
      
      Throw New Exception("2")
   End Sub
   
   Sub MyHandler(sender As Object, args As UnhandledExceptionEventArgs)
      Dim e As Exception = DirectCast(args.ExceptionObject, Exception)
      Console.WriteLine("MyHandler caught : " + e.Message)
      Console.WriteLine("Runtime terminating: {0}", args.IsTerminating)
   End Sub
End Module
' The example displays the following output:
'       Catch clause caught : 1
'       
'       MyHandler caught : 2
'       Runtime terminating: True
'       
'       Unhandled Exception: System.Exception: 2
'          at Example.Main()

Commenti

Questo evento fornisce la notifica delle eccezioni non rilevate.This event provides notification of uncaught exceptions. Consente all'applicazione di registrare informazioni sull'eccezione prima che il gestore predefinito del sistema segnali l'eccezione all'utente e termini l'applicazione.It allows the application to log information about the exception before the system default handler reports the exception to the user and terminates the application. Se sono disponibili informazioni sufficienti sullo stato dell'applicazione, è possibile che vengano intraprese altre azioni, ad esempio il salvataggio dei dati del programma per il ripristino successivo.If sufficient information about the state of the application is available, other actions may be undertaken - such as saving program data for later recovery. Si consiglia di prestare attenzione, perché i dati del programma possono essere danneggiati quando le eccezioni non vengono gestite.Caution is advised, because program data can become corrupted when exceptions are not handled.

Nota

Nelle versioni .NET Framework 1,0 e 1,1, le opzioni di terminazione e debug dell'applicazione vengono segnalate all'utente prima che venga generato questo evento, anziché dopo.In the .NET Framework versions 1.0 and 1.1, application termination and debugging options are reported to the user before this event is raised, rather than after.

Questo evento può essere gestito in qualsiasi dominio applicazione.This event can be handled in any application domain. Tuttavia, l'evento non viene generato necessariamente nel dominio applicazione in cui si è verificata l'eccezione.However, the event is not necessarily raised in the application domain where the exception occurred. Un'eccezione non viene gestita solo se l'intero stack per il thread è stato rimosso senza trovare un gestore di eccezioni applicabile, pertanto la prima posizione in cui l'evento può essere generato si trova nel dominio applicazione in cui ha avuto origine il thread.An exception is unhandled only if the entire stack for the thread has been unwound without finding an applicable exception handler, so the first place the event can be raised is in the application domain where the thread originated.

Nota

Nelle versioni .NET Framework 1,0 e 1,1, questo evento si verifica solo per il dominio applicazione predefinito creato dal sistema all'avvio di un'applicazione.In the .NET Framework versions 1.0 and 1.1, this event occurs only for the default application domain that is created by the system when an application is started. Se un'applicazione crea domini applicazione aggiuntivi, la specifica di un delegato per questo evento nei domini delle applicazioni non ha alcun effetto.If an application creates additional application domains, specifying a delegate for this event in those applications domains has no effect.

Se l' UnhandledException evento viene gestito nel dominio applicazione predefinito, viene generato per qualsiasi eccezione non gestita in un thread, indipendentemente dal dominio dell'applicazione in cui è stato avviato il thread.If the UnhandledException event is handled in the default application domain, it is raised there for any unhandled exception in any thread, no matter what application domain the thread started in. Se il thread è stato avviato in un dominio applicazione che dispone di un UnhandledExceptiongestore eventi per, l'evento viene generato in tale dominio applicazione.If the thread started in an application domain that has an event handler for UnhandledException, the event is raised in that application domain. Se il dominio applicazione non è il dominio applicazione predefinito ed è presente anche un gestore eventi nel dominio applicazione predefinito, l'evento viene generato in entrambi i domini applicazione.If that application domain is not the default application domain, and there is also an event handler in the default application domain, the event is raised in both application domains.

Si supponga, ad esempio, che un thread venga avviato nel dominio applicazione "AD1", chiami un metodo nel dominio applicazione "AD2" e da una chiamata a un metodo nel dominio applicazione "AD3", in cui viene generata un'eccezione.For example, suppose a thread starts in application domain "AD1", calls a method in application domain "AD2", and from there calls a method in application domain "AD3", where it throws an exception. Il primo dominio dell'applicazione in cui UnhandledException è possibile generare l'evento è "AD1".The first application domain in which the UnhandledException event can be raised is "AD1". Se il dominio applicazione non è il dominio applicazione predefinito, l'evento può essere generato anche nel dominio applicazione predefinito.If that application domain is not the default application domain, the event can also be raised in the default application domain.

Nota

Il Common Language Runtime sospende le interruzioni di thread mentre sono in esecuzione i UnhandledException gestori eventi per l'evento.The common language runtime suspends thread aborts while event handlers for the UnhandledException event are executing.

Se il gestore eventi dispone di ReliabilityContractAttribute un attributo con i flag appropriati, il gestore eventi viene considerato come un'area di esecuzione vincolata.If the event handler has a ReliabilityContractAttribute attribute with the appropriate flags, the event handler is treated as a constrained execution region.

A partire da .NET Framework 4.NET Framework 4, questo evento non viene generato per le eccezioni che danneggiano lo stato del processo, ad esempio overflow dello stack o violazioni di accesso, a meno che il gestore eventi non sia critico per la sicurezza HandleProcessCorruptedStateExceptionsAttribute e disponga dell'attributo.Starting with the .NET Framework 4.NET Framework 4, this event is not raised for exceptions that corrupt the state of the process, such as stack overflows or access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

Nelle versioni .NET Framework 1,0 e 1,1, un'eccezione non gestita che si verifica in un thread diverso dal thread dell'applicazione principale viene intercettata dal runtime e pertanto non comporta l'interruzione dell'applicazione.In the .NET Framework versions 1.0 and 1.1, an unhandled exception that occurs in a thread other than the main application thread is caught by the runtime and therefore does not cause the application to terminate. Pertanto, è possibile che l' UnhandledException evento venga generato senza terminare l'applicazione.Thus, it is possible for the UnhandledException event to be raised without the application terminating. A partire dalla versione .NET Framework 2,0, questo backstop per le eccezioni non gestite nei thread figlio è stato rimosso, perché l'effetto cumulativo di tali errori in modalità invisibile all'utente includeva riduzione delle prestazioni, dati danneggiati e blocchi, che erano tutti difficili da debug.Starting with the .NET Framework version 2.0, this backstop for unhandled exceptions in child threads was removed, because the cumulative effect of such silent failures included performance degradation, corrupted data, and lockups, all of which were difficult to debug. Per ulteriori informazioni, incluso un elenco di casi in cui il runtime non termina, vedere eccezioni nei thread gestiti.For more information, including a list of cases in which the runtime does not terminate, see Exceptions in Managed Threads.

Per registrare un gestore eventi per questo evento, è necessario disporre delle autorizzazioni necessarie oppure viene generata SecurityException un'eccezione.To register an event handler for this event, you must have the required permissions, or a SecurityException is thrown.

Per ulteriori informazioni sulla gestione degli eventi, consultare gestione e generazione di eventi.For more information about handling events, see Handling and Raising Events.

Altri eventi per le eccezioni non gestiteOther Events for Unhandled Exceptions

Per alcuni modelli di applicazione, UnhandledException l'evento può essere interrotto da altri eventi se l'eccezione non gestita si verifica nel thread dell'applicazione principale.For certain application models, the UnhandledException event can be preempted by other events if the unhandled exception occurs in the main application thread.

Nelle applicazioni che utilizzano Windows Forms, le eccezioni non gestite nel thread principale dell'applicazione provocano Application.ThreadException la generazione dell'evento.In applications that use Windows Forms, unhandled exceptions in the main application thread cause the Application.ThreadException event to be raised. Se questo evento viene gestito, il comportamento predefinito è che l'eccezione non gestita non termina l'applicazione, anche se l'applicazione viene lasciata in uno stato sconosciuto.If this event is handled, the default behavior is that the unhandled exception does not terminate the application, although the application is left in an unknown state. In tal caso, l' UnhandledException evento non viene generato.In that case, the UnhandledException event is not raised. Questo comportamento può essere modificato tramite il file di configurazione dell'applicazione o tramite il Application.SetUnhandledExceptionMode metodo per impostare la modalità su prima che UnhandledExceptionMode.ThrowException il ThreadException gestore eventi venga associato.This behavior can be changed by using the application configuration file, or by using the Application.SetUnhandledExceptionMode method to change the mode to UnhandledExceptionMode.ThrowException before the ThreadException event handler is hooked up. Si applica solo al thread principale dell'applicazione.This applies only to the main application thread. L' UnhandledException evento viene generato per le eccezioni non gestite generate in altri thread.The UnhandledException event is raised for unhandled exceptions thrown in other threads.

A partire da Microsoft Visual Studio 2005, il Framework dell'applicazione Visual Basic fornisce un altro evento per le eccezioni non gestite nel thread principale dell'applicazione.Starting with Microsoft Visual Studio 2005, the Visual Basic application framework provides another event for unhandled exceptions in the main application thread. Vedere l' WindowsFormsApplicationBase.UnhandledException evento.See the WindowsFormsApplicationBase.UnhandledException event. Questo evento dispone di un oggetto arguments di evento con lo stesso nome dell'oggetto arguments AppDomain.UnhandledExceptiondell'evento usato da, ma con proprietà diverse.This event has an event arguments object with the same name as the event arguments object used by AppDomain.UnhandledException, but with different properties. In particolare, questo oggetto arguments dell'evento ExitApplication dispone di una proprietà che consente l'esecuzione dell'applicazione, ignorando l'eccezione non gestita e lasciando l'applicazione in uno stato sconosciuto.In particular, this event arguments object has an ExitApplication property that allows the application to continue running, ignoring the unhandled exception (and leaving the application in an unknown state). In tal caso, l' AppDomain.UnhandledException evento non viene generato.In that case, the AppDomain.UnhandledException event is not raised.

Sicurezza

SecurityCriticalAttribute
richiede l'attendibilità totale per il chiamante immediato.requires full trust for the immediate caller. Questo membro non può essere utilizzato da codice parzialmente attendibile o trasparente.This member cannot be used by partially trusted or transparent code.

Si applica a